#include <mpi.h>
#include <stdio.h>

#define ROOT 0
#define MSGLEN 100

int main(int argc, char **argv)
{
    int i, rank, size, nlen, tag = 999;
    char name[MPI_MAX_PROCESSOR_NAME];  
    char recvmsg[MSGLEN], sendmsg[MSGLEN];
    MPI_Status stats;

    MPI_Init(&argc, &argv);
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);
    MPI_Comm_size(MPI_COMM_WORLD, &size);
    MPI_Get_processor_name(name, &nlen);

    sprintf(sendmsg, "Hello world! I am process %d out of %d on %s\n", rank, size, name);

    if (rank == ROOT) {
        printf("Message from process %d: %s", ROOT, sendmsg);
        for (i = 1; i < size; ++i) {
            MPI_Recv(&recvmsg, MSGLEN, MPI_CHAR, i, tag, MPI_COMM_WORLD, &stats);
            printf("Message from process %d: %s", i, recvmsg);
        }
    } else {
        MPI_Send(&sendmsg, MSGLEN, MPI_CHAR, ROOT, tag, MPI_COMM_WORLD);
    }

    MPI_Finalize();
    return 0;
}

