#include <mpi.h>
#include <stdio.h>

#define ROOT 0

int main(int argc, char **argv)
{
    int rank, size, next, prev, buf[2], tag1=999, tag2=777;
    MPI_Request reqs[4];
    MPI_Status stats[4];

    MPI_Init(&argc, &argv);
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);
    MPI_Comm_size(MPI_COMM_WORLD, &size);

    prev = rank-1;
    next = rank+1;
    if (rank == ROOT)  prev = size - 1;
    if (rank == (size - 1))  next = ROOT;

    MPI_Irecv(&buf[0], 1, MPI_INT, prev, tag1, MPI_COMM_WORLD, &reqs[0]);
    MPI_Irecv(&buf[1], 1, MPI_INT, next, tag2, MPI_COMM_WORLD, &reqs[1]);

    MPI_Isend(&rank, 1, MPI_INT, prev, tag2, MPI_COMM_WORLD, &reqs[2]);
    MPI_Isend(&rank, 1, MPI_INT, next, tag1, MPI_COMM_WORLD, &reqs[3]);

    /* do some work */

    MPI_Waitall(4, reqs, stats);

    MPI_Finalize();
    return 0;
}

